<?PHP
// A few permissions need to be correct. The 'users' directory must be readable and
// writable by the user/group of the web server process in order for addressbooks/identities/settings to work properly.
class	AddressBook {
	var $xmldoc;

	function AddressBook($key=false) {
		if(!function_exists("domxml_open_file")) {
			return false;
		}

		if ((!file_exists("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml")) && (!file_exists("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted"))) {
			if(file_exists("include/empty.xml")) {
				if(!file_exists("users/" . md5($_SESSION["emailaddress"]) . "")) {
					if (mkdir_p("users/" . md5($_SESSION["emailaddress"])) === false) {
						return false;
					}
				}
				copy("include/empty.xml", "users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml");
			} else {
				return false;
			}
		}

		if ($key === false) {
			$key = $_SESSION["password"];
		}
		if (($_SESSION["encryptaddressbooks"] == 1) && (function_exists("mcrypt_module_open"))) {
			// Initialize our cryptographic swankness
			$td = mcrypt_module_open ('rijndael-256', '', 'ecb', '');
			$key = substr ($key, 0, mcrypt_enc_get_key_size ($td));
			$iv_size = mcrypt_enc_get_iv_size ($td);
			$iv = mcrypt_create_iv ($iv_size, MCRYPT_DEV_URANDOM);

			// Now we deal with some weirdness about turning on and off encryption.
			if (!is_file("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted")) {
				// We have no encrypted addressbook, so we open the normal one
				$this->xmldoc = domxml_open_file("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml");
				mcrypt_generic_init($td, $key, $iv);
				$encrypted_addressbook = mcrypt_generic($td, $this->xmldoc->dump_mem(false));

				// Then save it encrypted
				$fp = fopen("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted", "wb+");
				fwrite($fp, $encrypted_addressbook);
				fclose($fp);
				@unlink("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml");
			} else {
				$fp = fopen("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted", "rb");
				$encrypted_addressbook = fread($fp, filesize ("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted"));
				fclose($fp);

				mcrypt_generic_init ($td, $key, $iv);
				$decrypted_addressbook = mdecrypt_generic ($td, $encrypted_addressbook);

				if (!($this->xmldoc = @domxml_open_mem($decrypted_addressbook))) {
					// If it's not really an xml file, let's return false because the
					// decryption probably didn't work.
					return false;
				}
			}
			mcrypt_generic_deinit ($td);
			mcrypt_module_close ($td);
		} else {
			// Deal with weirdness turning on and off encryption
			if (!is_file("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml")) {
				// There is no normal one, so we have to decrypt the encrypted one
				// Initialize our cryptographic swankness
				$td = mcrypt_module_open ('rijndael-256', '', 'ecb', '');
				$key = substr ($key, 0, mcrypt_enc_get_key_size ($td));
				$iv_size = mcrypt_enc_get_iv_size ($td);
				$iv = mcrypt_create_iv ($iv_size, MCRYPT_DEV_URANDOM);

				$fp = fopen("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted", "rb");
				$encrypted_addressbook = fread($fp, filesize ("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted"));
				fclose($fp);

				mcrypt_generic_init ($td, $key, $iv);
				$decrypted_addressbook = mdecrypt_generic ($td, $encrypted_addressbook);

				if (!($this->xmldoc = @domxml_open_mem($decrypted_addressbook))) {
					// If it's not really an xml file, let's return false because the
					// decryption probably didn't work.
					return false;
				}
				@unlink("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted");
				$this->_SaveAddressBook();
			} else {
				$this->xmldoc = domxml_open_file("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml");
			}
		}

		if(!$this->xmldoc)
			return false;
		else
			return true;
	}

	function GetEntries() {
		$entries = array();
		$entrynodes = $this->xmldoc->get_elements_by_tagname("entry");
		$arr = array();
		for ($i = 0; $i < count($entrynodes); $i++) {
			$info = $this->GetEntryInfo($entrynodes[$i]->get_attribute("id"));
			$arr[$entrynodes[$i]->get_attribute("id")] = $info["name"];
		}
		asort($arr);
		$counter = 0;
		while (list($id, $name) = each($arr)) {
			$entries[$counter]["id"] = $id;
			$entries[$counter]["name"] = $name;
			$counter++;
		}
		return $entries;
	}

	function GetEntryInfo($entryid) {
		$entry = array();
		$entry["name"] = "";

		$context = xpath_new_context($this->xmldoc);
		$entry_ns = xpath_eval($context, "/addressdb/entries/entry[@id=\"" . $entryid . "\"]");
		if (count($entry_ns->nodeset) != 1) {
			return false;
		} else {
			$entrynode = $entry_ns->nodeset[0];
		}
		$name = $entrynode->get_elements_by_tagname("name");
		$name = $name[0];
		$entry["first"] = html_entity_decode($name->get_attribute("first"));
		$entry["middle"] = html_entity_decode($name->get_attribute("middle"));
		$entry["last"] = html_entity_decode($name->get_attribute("last"));
		$entry["nickname"] = html_entity_decode($name->get_attribute("nickname"));
		$entry["emails"] = array();
		$emails = $entrynode->get_elements_by_tagname("email");
		for ($i = 0; $i < count($emails); $i++) {
			$entry["emails"][$i] = html_entity_decode($emails[$i]->get_attribute("value"));
			if ($emails[$i]->has_attribute("default")) {
				$entry["default"] = $entry["emails"][$i];
			}
		}

		// Now set the name to show up in the listings
		if ($entry["nickname"]) {
			$entry["name"] = $entry["nickname"];
		}
		if ($entry["name"] == "") {
			// Get a name if there is one
			$str = $entry["last"];
			if (($str != "") && (($entry["first"] != "") || ($entry["middle"] != ""))){
				$str .= ", ";
			}
			$str .= trim($entry["first"] . " " . $entry["middle"]);
			if ($str != "") {
				$entry["name"] = $str;
			}
		}
		if ($entry["name"] == "") {
			// If it got this far, spit out an e-mail address
			if (count($entry["emails"]) == 0) {
				$entry["name"] = "No Information";
			} else {
				$entry["name"] = $entry["emails"][0];
			}
		}
		return $entry;
	}

	function SetEntryName($entryid, $name) {
		$name = explode(" ", $name);
		$first = "";
		$middle = "";
		$last = "";
		$arr = array();
		if (count($name) > 0) {
			// Put the name in the correct order
			for ($i = count($name) - 1; $i >= 0; $i--) {
				if (strstr($name[$i], ",") == true) {
					array_push($arr, str_replace(",", "", $name[$i]));
				} else {
					array_unshift($arr, $name[$i]);
				}
			}
			$name = $arr;
			unset($arr);
			// Now figure out what is first, middle, and last
			$first = $name[0];
			if (count($name) == 2) {
				$last = $name[1];
			} else if (count($name) >= 3) {
				$last = $name[count($name) - 1];
				for ($i = 1; $i < count($name) - 1; $i++) {
					$middle .= $name[$i] . " ";
				}
				$middle = trim($middle);
			}
		}

		$context = xpath_new_context($this->xmldoc);
		$entry_ns = xpath_eval($context, "/addressdb/entries/entry[@id=\"" . (int)$entryid . "\"]");
		$entry = $entry_ns->nodeset;
		if (count($entry) > 0) {
			$name = $entry[0]->get_elements_by_tagname("name");
			$name[0]->set_attribute("first", htmlentities($first));
			$name[0]->set_attribute("middle", htmlentities($middle));
			$name[0]->set_attribute("last", htmlentities($last));
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function SetSetting($setting, $value) {
		$context = xpath_new_context($this->xmldoc);
		if (!$this->_HasSettingNode($context, $setting)) {
			$newelement = $this->xmldoc->create_element($setting);
			$settings = $this->xmldoc->get_elements_by_tagname("settings");
			$settings[0]->append_child($newelement);
		}
		$settingnode = xpath_eval($context, "/addressdb/settings/" . $setting);
		$settingnode = $settingnode->nodeset[0];
		$settingnode->set_attribute("value", htmlentities($value));
		$this->_SaveAddressBook();
	}

	function _HasSettingNode($context, $tagname) {
		$setting = xpath_eval($context, "/addressdb/settings/" . $tagname);
		$setting = $setting->nodeset;
		if (count($setting) != 1) {
			return false;
		} else {
			return true;
		}
	}

	function AddIdentity($name) {
		$identities = $this->xmldoc->get_elements_by_tagname("identities");
		if (count($identities) == 0) {
			// If it isn't there, we have to add it
        	        $addressdb = $this->xmldoc->get_elements_by_tagname("addressdb");
                	$identities = $this->xmldoc->create_element("identities");
                	$addressdb[0]->append_child($identities);
			$identities = $this->xmldoc->get_elements_by_tagname("identities");
		}
		$identities = $identities[0];
		$lastid = $this->xmldoc->get_elements_by_tagname("lastid");
		$index = $lastid[0]->get_attribute("value");
		$index++;
		$lastid[0]->set_attribute("value", $index);
		$identity = $this->xmldoc->create_element("identity");
		$identity->set_attribute("id", $index);
		$identity->set_attribute("name", htmlentities($name));
		$displayname = $this->xmldoc->create_element("displayname");
		$displayname->set_attribute("value", "");
		$identity->append_child($displayname);
		$replyto = $this->xmldoc->create_element("replyto");
		$replyto->set_attribute("value", "");
		$identity->append_child($replyto);
		$organization = $this->xmldoc->create_element("organization");
		$organization->set_attribute("value", "");
		$identity->append_child($organization);
		$identities->append_child($identity);
		$this->_SaveAddressBook();
		return $index;
	}

	function DeleteIdentity($identityid) {
		$context = xpath_new_context($this->xmldoc);

		$identities = $this->xmldoc->get_elements_by_tagname("identities");
		$identities = $identities[0];

		// Make sure we aren't deleting the last one
		if (count($identities->child_nodes()) <= 1) {
			return false;
		}

		// Make sure this is actually there
		$identity_ns = xpath_eval($context, "/addressdb/identities/identity[@id=\"" . $identityid . "\"]");
		$identity_ns = $identity_ns->nodeset;
		if (count($identity_ns) == 0) {
			return false;
		}

		// If we can remove it, let's do so.
		$identities->remove_child($identity_ns[0]);
		$this->_SaveAddressBook();
	}

	function SetIdentityName($identityid, $name) {
		$context = xpath_new_context($this->xmldoc);

                $identity_ns = xpath_eval($context, "/addressdb/identities/identity[@id=\"" . (int)$identityid . "\"]");
                $identity_ns = $identity_ns->nodeset;
                if (count($identity_ns) == 0) {
                        return false;
                }
		if (trim($name) != "") {
			$identity_ns[0]->set_attribute("name", htmlentities(trim($name)));
		}
		return true;
	}

	function SetIdentityAttribute($identityid, $attribute, $value) {
		$context = xpath_new_context($this->xmldoc);

                $identity_ns = xpath_eval($context, "/addressdb/identities/identity[@id=\"" . (int)$identityid . "\"]");
                $identity_ns = $identity_ns->nodeset;
                if (count($identity_ns) == 0) {
                        return false;
                }
		$nodes = $identity_ns[0]->get_elements_by_tagname($attribute);
		if (count($nodes) > 0) {
			$node = $nodes[0];
		} else {
			$node = $xmldoc->create_element($attribute);
			$identity_ns[0]->append_child($node);
		}
		$node->set_attribute("value", htmlentities(trim($value)));
		$this->_SaveAddressBook();
		return true;
	}

	function ChangeEmail($entryid, $old, $new) {
		$context = xpath_new_context($this->xmldoc);
		$emails_ns = xpath_eval($context, "/addressdb/entries/entry/email[@value=\"" . $old . "\"]");
		$emails = $emails_ns->nodeset;
		if (count($emails) > 0) {
			$emails[0]->set_attribute("value", htmlentities($new));
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function DeleteEmail($entryid, $email) {
		$context = xpath_new_context($this->xmldoc);
		$emails_ns = xpath_eval($context, "/addressdb/entries/entry[@id=\"" . $entryid . "\"]/email[@value=\"" . $email . "\"]");
		$emails = $emails_ns->nodeset;
		if (count($emails) > 0) {
			$emailsection = $emails[0]->parent_node();
			$emailsection->remove_child($emails[0]);
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function SetDefaultEmail($entryid, $email) {
		$context = xpath_new_context($this->xmldoc);
		$entry_ns = xpath_eval($context, "/addressdb/entries/entry[@id=\"" . (int)$entryid . "\"]");
		$entry = $entry_ns->nodeset;
		if (count($entry) > 0) {
			$emails = $entry[0]->get_elements_by_tagname("email");
			for ($i = 0; $i < count($emails); $i++) {
				if (html_entity_decode($emails[$i]->get_attribute("value")) == $email) {
					$emails[$i]->set_attribute("default", "1");
				} else {
					$emails[$i]->remove_attribute("default");
				}
			}
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function SetEntryNickname($entryid, $nickname) {
		$context = xpath_new_context($this->xmldoc);
		$entry_ns = xpath_eval($context, "/addressdb/entries/entry[@id=\"" . (int)$entryid . "\"]");
		$entry = $entry_ns->nodeset;
		if (count($entry) > 0) {
			$name = $entry[0]->get_elements_by_tagname("name");
			$name[0]->set_attribute("nickname", htmlentities($nickname));
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function AddEmailAddress($entryid, $email) {
		$context = xpath_new_context($this->xmldoc);
		$entries_ns = xpath_eval($context, "/addressdb/entries/entry[@id=\"" . $entryid . "\"]");
		$entries = $entries_ns->nodeset;
		if (count($entries) > 0) {
			$entry = $entries[0];
			$newemail = $this->xmldoc->create_element("email");
			$newemail->set_attribute("value", htmlentities($email));
			$entry->append_child($newemail);
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function AddEntry($addressinfo) {
		// Seperate out the name from the e-mail address
		// Find an address - this is the simple way that does *some* validating - we can make this much much nastier if we have to
		preg_match_all("/([\w\.\-_]+@[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3})/", $addressinfo, $matches);
		if (count($matches[0]) == 0) {
			// There is no e-mail address, and we can't possibly add it. Foonutz.
			return array("code"=>0, "id"=>0);
		} else {
			$email = strtolower($matches[1][0]);
		}

		// Get the stuff in quotes if it is
		preg_match_all("/\"([^\"]+)\"/", $addressinfo, $matches);
		if (isset($matches[1][0])) {
			$name = str_replace("\"", "", $matches[1][0]);
		} else {
			$name = "";
		}
		if ($name == "") {
			$name = array();
			// there are no quotes, get the stuff anyway
			preg_match_all("/([^\s]+)/", $addressinfo, $matches);
			for ($i = 0; $i < count($matches[0]); $i++) {
				if (strstr($matches[0][$i], "@") == false) {
					$name[$i] = $matches[0][$i];
				}
			}
		} else {
			$name = split(" ", $name);
		}
		// Now we parse the name into what is likely first and last. If there is any.
		$first = "";
		$middle = "";
		$last = "";
		$arr = array();
		if (count($name) > 0) {
			// Put the name in the correct order
			for ($i = count($name) - 1; $i >= 0; $i--) {
				if (strstr($name[$i], ",") == true) {
					array_push($arr, str_replace(",", "", $name[$i]));
				} else {
					array_unshift($arr, $name[$i]);
				}
			}
			$name = $arr;
			unset($arr);
			// Now figure out what is first, middle, and last
			$first = $name[0];
			if (count($name) == 2) {
				$last = $name[1];
			} else if (count($name) >= 3) {
				$last = $name[count($name) - 1];
				for ($i = 1; $i < count($name) - 1; $i++) {
					$middle .= $name[$i] . " ";
				}
				$middle = trim($middle);
			}

		}
		// Get everything but the address, if there is some
		$context = xpath_new_context($this->xmldoc);

		// First, we shall see if this email address exists already
		$entry_ns = xpath_eval($context, "/addressdb/entries/entry/email[@value=\"" . $email . "\"]");
		$entry = $entry_ns->nodeset;
		if (count($entry) > 0) {
			// This e-mail address is already in the addressbook
			return array("code"=>2, "id"=>0);
		}
		// If there is no name info, let's just add it as something new
		if ($first == "" && $middle == "" && $last == "") {
			// Get the id and increment it
			$lastid = $this->xmldoc->get_elements_by_tagname("lastid");
			$index = $lastid[0]->get_attribute("value");
			$index++;
			$lastid[0]->set_attribute("value", $index);

			// Make our entry node
			$entry = $this->xmldoc->create_element("entry");
			$entry->set_attribute("id", $index);

			// Add our name node and add it as a child to the entry
			$namenode = $this->xmldoc->create_element("name");
			$namenode->set_attribute("first", "");
			$namenode->set_attribute("middle", "");
			$namenode->set_attribute("last", "");
			$namenode->set_attribute("nickname", "");
			$entry->append_child($namenode);

			// Add our name node and add it as a child to the entry
			$emailnode = $this->xmldoc->create_element("email");
			$emailnode->set_attribute("value", htmlentities($email));
			$emailnode->set_attribute("default", "1");
			$entry->append_child($emailnode);

			$entries = $this->xmldoc->get_elements_by_tagname("entries");
			$entries = $entries[0];
			$entries->append_child($entry);
			$this->_SaveAddressBook();
			return array("code"=>1, "id"=>$index);
		}

		// If the e-mail isn't there, and there exists some form of name, we'll use that.
		// The e-mail address was not found, maybe we should add it. Let's see if we have a place to add it.
		$entry_ns = xpath_eval($context, "/addressdb/entries/entry/name[translate(@first, \"ABCDEFGHIJKLMNOPQRSTUVWXYZ\", \"abcdefghijklmnopqrstuvwxyz\")=\"" . addslashes(strtolower($first)) . "\" and
							translate(@middle, \"ABCDEFGHIJKLMNOPQRSTUVWXYZ\", \"abcdefghijklmnopqrstuvwxyz\")=\"" . addslashes(strtolower($middle)) . "\" and
							translate(@last, \"ABCDEFGHIJKLMNOPQRSTUVWXYZ\", \"abcdefghijklmnopqrstuvwxyz\")=\"" . addslashes(strtolower($last)) . "\"]/..");
		$entry = $entry_ns->nodeset;
		if (count($entry) > 0) {
			$newemail = $this->xmldoc->create_element("email");
			$newemail->set_attribute("value", htmlentities($email));
			$entry[0]->append_sibling($newemail);
			$index = $entry[0]->get_attribute("id");
			$this->_SaveAddressBook();
			return array("code"=>1, "id"=>$index);
		} else {
			// Get the id and increment it
			$lastid = $this->xmldoc->get_elements_by_tagname("lastid");
			$index = $lastid[0]->get_attribute("value");
			$index++;
			$lastid[0]->set_attribute("value", $index);

			// Make our entry node
			$entry = $this->xmldoc->create_element("entry");
			$entry->set_attribute("id", $index);

			// Add our name node and add it as a child to the entry
			$namenode = $this->xmldoc->create_element("name");
			$namenode->set_attribute("first", htmlentities($first));
			$namenode->set_attribute("middle", htmlentities($middle));
			$namenode->set_attribute("last", htmlentities($last));
			$namenode->set_attribute("nickname", "");
			$entry->append_child($namenode);

			// Add our name node and add it as a child to the entry
			$emailnode = $this->xmldoc->create_element("email");
			$emailnode->set_attribute("value", htmlentities($email));
			$entry->append_child($emailnode);

			$entries = $this->xmldoc->get_elements_by_tagname("entries");
			$entries = $entries[0];
			$entries->append_child($entry);
			$this->_SaveAddressBook();
			return array("code"=>1, "id"=>$index);
		}
	}

	function DeleteEntry($entryid) {
		$context = xpath_new_context($this->xmldoc);
		$entries_ns = xpath_eval($context, "/addressdb/entries/entry[@id=\"" . $entryid . "\"]");
		$entries = $entries_ns->nodeset;
		if (count($entries) > 0) {
			$entry = $entries[0];
			$entries = $this->xmldoc->get_elements_by_tagname("entries");
			$entries = $entries[0];
			$entries->remove_child($entry);
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function SetSorting($field) {
		if (($field == "subject") || ($field == "from") || ($field == "date")) {
			$msgsortfield = $this->xmldoc->get_elements_by_tagname("sortfield");
			$msgsortdirection = $this->xmldoc->get_elements_by_tagname("sortdirection");
			if ($msgsortfield[0]->get_attribute("value") == $field) {
				if ($msgsortdirection[0]->get_attribute("value") == "asc") {
					$msgsortdirection[0]->set_attribute("value", "desc");
					$_SESSION["sortdirection"] = "desc";
				} else {
					$msgsortdirection[0]->set_attribute("value", "asc");
					$_SESSION["sortdirection"] = "asc";
				}
			} else {
				$msgsortfield[0]->set_attribute("value", $field);
				$msgsortdirection[0]->set_attribute("value", "desc");
				$_SESSION["sortfield"] = $field;
				$_SESSION["sortdirection"] = "desc";
			}
			$this->_SaveAddressBook();
			return true;
		} else {
			return false;
		}
	}

	function GetSettings() {
		while (list($key, $val) = each($GLOBALS["defaultsettings"])) {
			$elements = $this->xmldoc->get_elements_by_tagname($key);
			if (count($elements) == 1) {
				$settings[$key] = html_entity_decode($elements[0]->get_attribute("value"));
			} else {
				$this->SetSetting($key, $val["default"]);
				$settings[$key] = $val["default"];
			}
		}

		return $settings;
	}

	function GetIdentities() {
		$identities = $this->xmldoc->get_elements_by_tagname("identities");
		if (count($identities) == 0) {
			// If there are no identities, then just return false
			return false;
		}
		$identities = $identities[0]->child_nodes();
		$arr = array();
		for ($i = 0; $i < count($identities); $i++) {
			$arr[$i]["id"] = $identities[$i]->get_attribute("id");
			$arr[$i]["name"] = html_entity_decode($identities[$i]->get_attribute("name"));
			if ($identities[$i]->has_attribute("default")) {
				$arr[$i]["isdefault"] = 1;
			} else {
				$arr[$i]["isdefault"] = 0;
			}
		}
		return $arr;
	}

	function GetIdentityInfo($identityid) {
		$context = xpath_new_context($this->xmldoc);

		$identity_ns = xpath_eval($context, "/addressdb/identities/identity[@id=\"" . $identityid . "\"]");
		$identity_ns = $identity_ns->nodeset;
		if (count($identity_ns) == 0) {
			return false;
		}

		// Set the identity name
		$identity["name"] = html_entity_decode($identity_ns[0]->get_attribute("name"));

		// Set the identity fromaddress
		$nodes = $identity_ns[0]->get_elements_by_tagname("fromaddress");
		if (count($nodes) == 0) {
			$newnode = $this->xmldoc->create_element("fromaddress");
			$newnode->set_attribute("value", "");
			$identity_ns[0]->append_child($newnode);
			$identity["fromaddress"] = "";
			$this->_SaveAddressBook();
		} else {
			$identity["fromaddress"] = html_entity_decode($nodes[0]->get_attribute("value"));
		}

		// Set the identity replyto
		$nodes = $identity_ns[0]->get_elements_by_tagname("replyto");
		if (count($nodes) == 0) {
			$newnode = $this->xmldoc->create_element("replyto");
			$newnode->set_attribute("value", "");
			$identity_ns[0]->append_child($newnode);
			$identity["replyto"] = "";
			$this->_SaveAddressBook();
		} else {
			$identity["replyto"] = html_entity_decode($nodes[0]->get_attribute("value"));
		}

		// Set the identity Display name
		$nodes = $identity_ns[0]->get_elements_by_tagname("displayname");
		if (count($nodes) == 0) {
			$newnode = $this->xmldoc->create_element("displayname");
			$newnode->set_attribute("value", "");
			$identity_ns[0]->append_child($newnode);
			$identity["displayname"] = "";
			$this->_SaveAddressBook();
		} else {
			$identity["displayname"] = html_entity_decode($nodes[0]->get_attribute("value"));
		}

		// Set the identity Organization name
		$nodes = $identity_ns[0]->get_elements_by_tagname("organization");
		if (count($nodes) == 0) {
			$newnode = $this->xmldoc->create_element("organization");
			$newnode->set_attribute("value", "");
			$identity_ns[0]->append_child($newnode);
			$identity["organization"] = "";
			$this->_SaveAddressBook();
		} else {
			$identity["organization"] = html_entity_decode($nodes[0]->get_attribute("value"));
		}

		// Set the identity signature
		$nodes = $identity_ns[0]->get_elements_by_tagname("signature");
		if (count($nodes) == 0) {
			$newnode = $this->xmldoc->create_element("signature");
			$newnode->set_attribute("value", "");
			$identity_ns[0]->append_child($newnode);
			$identity["signature"] = "";
			$this->_SaveAddressBook();
		} else {
			$identity["signature"] = html_entity_decode($nodes[0]->get_attribute("value"));
		}

		return $identity;
	}

	function _SaveAddressBook($key=false) {
		if (($_SESSION["encryptaddressbooks"] == 1) && (function_exists("mcrypt_module_open"))) {
			$addressbook = $this->xmldoc->dump_mem(false);
			if ($key === false) {
				$key = $_SESSION["password"];
			}

			$td = mcrypt_module_open ('rijndael-256', '', 'ecb', '');
			$key = substr ($key, 0, mcrypt_enc_get_key_size ($td));
			$iv_size = mcrypt_enc_get_iv_size ($td);
			$iv = mcrypt_create_iv ($iv_size, MCRYPT_DEV_URANDOM);

			mcrypt_generic_init ($td, $key, $iv);
			$encrypted_addressbook = mcrypt_generic ($td, $addressbook);

			mcrypt_generic_deinit ($td);
			mcrypt_module_close ($td);

			$fp = fopen("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml.encrypted", "wb+");
			fwrite($fp, $encrypted_addressbook);
			fclose($fp);
		} else {
			$this->xmldoc->dump_file("users/" . md5($_SESSION["emailaddress"]) . "/addressbook.xml", false, true);
		}
	}
}
?>
