<?PHP
	$noredirect = true;
	include "include/globals.php";
	include "include/conffilefunctions.php";
	include "include/mailfunctions.php";

	if(isset($_POST["loginusername"])) {
		if ($_POST["logindomain"] == 'default') {
			header("Location: error.php?error=" . urlencode(gettext("Domain 'Default' is an invalid domain")));
			exit;
		}
		$domains = getconffiledomains();
		$config = readconffile($_POST['loginusername'], $domains[$_POST['logindomain']]);
		if(isset($config['error'])) {
			header("Location: error.php?error=" . urlencode($config['error']));
			exit;
		}

		session_name("ISMAIL");

		// check for a valid login before passing them on
		$mbox = open_mailbox("{" . $config['server'] . ":" . $config['port'] . "/" . $config['protocol'] . "/notls}" . $config["rootfolderpath"], $config['usernameprefix'] . $_POST['loginusername'] . $config['usernamesuffix'], $_POST['loginpassword']);

		$_SESSION["currentfolder"] = "";
		$_SESSION["currentmessage"] = "-1";
		$_SESSION["lastmessage"] = "";
		$_SESSION['imapflavor'] = $config['imapflavor'];
		$_SESSION['domain'] = $config['domain'];
		$_SESSION['server'] = $config['server'];
		$_SESSION['smtpserver'] = $config['smtpserver'];
		$_SESSION['port'] = $config['port'];
		$_SESSION['protocol'] = $config['protocol'];
		$_SESSION['folderseparator'] = $config['folderseparator'];
		$_SESSION['imapserversorting'] = $config['serversorting'];
		$_SESSION['sentfoldername'] = $config['sentitemsfolder'];
		if($config['tls'] === false)
			$_SESSION['serverstring'] = "{" . $config['server'] . ":" . $config['port'] . "/" . $config['protocol'] . "/notls}";
		else
			$_SESSION['serverstring'] = "{" . $config['server'] . ":" . $config['port'] . "/" . $config['protocol'] . "}";
		$_SESSION['rootfolderpath'] = $config['rootfolderpath'];
		$_SESSION['currentfolder'] = $_SESSION['serverstring'] . $config['rootfolderpath'];
		if ($_SESSION['rootfolderpath'] != '') {
			$_SESSION['rootfolderpath'] .= $_SESSION['folderseparator'];
		}
		
		$_SESSION['usernameprefix'] = $config['usernameprefix'];
		$_SESSION['usernamesuffix'] = $config['usernamesuffix'];
		$_SESSION['baseusername'] = $_POST['loginusername'];
		$_SESSION['username'] = $config['usernameprefix'] . $_POST['loginusername'] . $config['usernamesuffix'];
		$_SESSION['password'] = $_POST['loginpassword'];
		$_SESSION['emailaddress'] = $config['email'];
		$_SESSION['addressbookstorage'] = $config['addressbookstorage'];
		$_SESSION['encryptaddressbooks'] = $config['encryptaddressbooks'];
		$_SESSION['extensionblacklist'] = $config['extensionblacklist'];
		$_SESSION['mailprogram'] = $config['mailprogram'];

		if($config['dictenable'] === true) {
			$_SESSION['dictenable'] = true;
			$_SESSION['dictcommand'] = $config['dictcommand'];
			$_SESSION['dictargs'] = $config['dictargs'];
		}
		else {
			$_SESSION['dictenable'] = false;
		}

		if($config['spellenable'] === true) {
			$_SESSION['spellenable'] = true;
			$_SESSION['spellcommand'] = $config['spellcommand'];
			$_SESSION['spellargs'] = $config['spellargs'];
		}
		else {
			$_SESSION['spellenable'] = false;
		}

		$_SESSION['themedir'] = $config['themedir'];
		$_SESSION['themeconfig'] = readthemefile($_SESSION['themedir']);
		if(isset($_SESSION['themeconfig']['error'])) {
			header("Location: error.php?error=" . urlencode($_SESSION['themeconfig']['error']));
			exit;
		}

		include $_SESSION['addressbookstorage'];

		// If the protocol is imap, we need to perform a few operations
		if ($_SESSION["protocol"] == "imap") {
			// create a proper sent items folder if they don't have one
			is_createmailbox($mbox,imap_utf7_encode($_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"]));

			//subscribe to their Inbox and Sent-items folder if they aren't already
			@imap_subscribe($mbox, $_SESSION["serverstring"] . "INBOX");
			@imap_subscribe($mbox, $_SESSION["serverstring"] . $_SESSION["rootfolderpath"] . $_SESSION["sentfoldername"]);
		}

		if (mkdir_p("./users/" . md5($_SESSION["emailaddress"])) === false) {
			header("Location: error.php?error=" . urlencode(gettext("Unable to create a user directory. Please contact your Administrator.")));
			exit;
		}
		$AddressBook = new AddressBook();
		if ($AddressBook === false) {
			imap_errors();
			imap_close($mbox);
			header("Location: addressbookdecrypt.php");
			exit;
		}
		SetSettings($AddressBook->GetSettings());
		imap_errors();
		imap_close($mbox);
		header("Location: ismail.php");
		exit;
	}

	$defaultconfig = readconffile("notloggedin", "default");
	if(isset($defaultconfig['error'])) {
		header("Location: error.php?error=" . urlencode($defaultconfig['error']));
		exit;
	}
	$domains = getconffiledomains();

	PageHeader(1);
?>
<head>
	<title><?php echo(gettext("Inside Systems Mail Login"));?></title>
	<style type="text/css">
		@import "themes/<?php echo($defaultconfig["themedir"]);?>/css/login.css";
	</style>
</head>
<body>
<div id="container">
<form id="loginform" method="post" action="login.php">
	<div id="logo">
	</div>
	<?php
		if (count($domains) == 1) {
			echo("<input type=\"hidden\" name=\"logindomain\" value=\"0\"/>\n");
		}
	?>
	<div id="programlabel">
		<span>
			Inside Systems Mail <?php echo($ismailversion);?>
		</span>
	</div>
	<div id="usernamelabel">
		<span><?php echo(gettext("Username"));?>:</span>
	</div>
	<div id="usernameinput">
		<input type="text" id="loginusername" name="loginusername"/>
	</div>
	<div id="passwordlabel">
		<span><?php echo(gettext("Password"));?>:</span>
	</div>
	<div id="passwordinput">
		<input type="password" name="loginpassword"/>
	</div>
	<?php
		echo("<div id=\"domainlabel\">\n");
		echo("	<span>" . gettext("Domain") . ":</span>\n");
		echo("</div>\n");
		if (count($domains) > 1) {
			echo("<div id=\"domaininput\">\n");
			echo("	<select name=\"logindomain\" size=\"1\">\n");
			for ($i = 0; $i < count($domains); $i++) {
				echo("		<option value=\"" . $i . "\">" . $domains[$i] . "</option>\n");
			}
			echo("	</select>\n");
			echo("</div>\n");
		} else {
			echo("<div id=\"domainsingle\">\n");
			echo("		" . $domains[0] . "\n");
			echo("</div>\n");
		}

	?>
	<div id="submitinput">
		<input type="submit" value=" <?php echo(gettext("Login"));?> "/>
	</div>
</form>
</div>
<script type="text/JavaScript">
	<!--
	document.getElementById('loginusername').focus();
	// -->
</script>
</body>
</html>
